/**
 * 
 */
package de.cesr.sonomode.analysis;

import java.util.Map;

import de.cesr.sesamgim.aggregate.GimAgentDissimilarityProvider;
import de.cesr.sonomode.agent.SonomodeAgent;

/**
 * @author Sascha Holzhauer
 *
 */
public class AgentDissimilarityProvider implements
		GimAgentDissimilarityProvider<SonomodeAgent> {

	/**
	 * @see de.cesr.sesamgim.aggregate.GimAgentDissimilarityProvider#getVertexDissimilarity(java.util.Map)
	 */
	@Override
	public double[][] getVertexDissimilarity(Map<SonomodeAgent, Integer> agents) {
		double[][] similarities = new double[agents.size()][agents.size()];
		for (SonomodeAgent outer : agents.keySet()) {
			for (SonomodeAgent inner : agents.keySet()) {
				similarities[agents.get(outer)][agents.get(inner)] = Math
						.abs(outer.getOpinion() - inner.getOpinion())
						+ Math.abs(outer.getUncertaint()
								- inner.getUncertaint());
			}
		}
		return similarities;
	}
}
