/**
 * 
 */
package de.cesr.sonomode.core;

import repast.simphony.random.RandomHelper;
import cern.jet.random.Uniform;

import de.cesr.parma.core.PmParameterManager;
import de.cesr.sesamgim.init.agent.GimAgentInitialiseService;
import de.cesr.sonomode.agent.ExtremeSonomodeAgent;
import de.cesr.sonomode.agent.ModerateSonomodeAgent;
import de.cesr.sonomode.agent.SonomodeAgent;
import de.cesr.sonomode.param.BasicPa;

/**
 * @author holzhauer
 *
 */
public class AgentInitService implements GimAgentInitialiseService<SonomodeAgent> {

	int extremPosition = 1;
	int numExtremAgents;
		
	public AgentInitService() {
		int num_total = ((Integer)PmParameterManager.getParameter(BasicPa.NUM_AGENTS)).intValue();
		numExtremAgents = (int) (num_total * ((Double)PmParameterManager.getParameter(BasicPa.PROP_EXTREMISTS)).doubleValue());
	}
	
	/**
	 * @see de.cesr.sesamgim.init.agent.GimAgentInitialiseService#initAgent(int)
	 */
	@Override
	public SonomodeAgent initAgent(int milieu) {
		SonomodeAgent agent = null;
		Uniform uniform = (Uniform) RandomHelper.getDistribution(ModelManager.RANDOM_OPINION);
		
		if (numExtremAgents > 0) {
			agent = new ExtremeSonomodeAgent(extremPosition, milieu);
			extremPosition *=-1;
			numExtremAgents--;
		} else {
			agent = new ModerateSonomodeAgent(uniform.nextDouble(), milieu);
		}
		return agent;
	}
}
