/**
 * 
 */
package de.cesr.sonomode.core;

import repast.simphony.parameter.IllegalParameterException;
import repast.simphony.random.RandomHelper;
import cern.jet.random.Uniform;
import de.cesr.sesamgim.init.agent.GimAgentInitialiseService;
import de.cesr.sonomode.agent.ExtremeSonomodeAgent;
import de.cesr.sonomode.agent.ModerateSonomodeAgent;
import de.cesr.sonomode.agent.SonomodeAgent;

/**
 * @author Sascha Holzhauer
 *
 */
public class ThreeMilieuAgentInitService implements
		GimAgentInitialiseService<SonomodeAgent> {

	@Override
	public SonomodeAgent initAgent(int milieu) {
		SonomodeAgent agent = null;
		Uniform uniform = (Uniform) RandomHelper
				.getDistribution(ModelManager.RANDOM_OPINION);

		switch (milieu) {
		case 1:
			agent = new ExtremeSonomodeAgent(1, milieu);
			break;
		case 2:
			agent = new ModerateSonomodeAgent(uniform.nextDouble(), milieu);
			break;
		case 3:
			agent = new ExtremeSonomodeAgent(-1, milieu);
			break;
		default:
			throw new IllegalParameterException(
					"The given milieu is not supported");
		}
		return agent;
	}
}
