/**
 * 
 */
package de.cesr.sonomode.function;

/**
 * @author holzhauer
 *
 */
public class BcKernelFunction implements KernelFunction {

	private BcKernelFunction() {};
	
	static KernelFunction function = null;
	
	static public KernelFunction getInstance() {
		if (function == null) {
			function = new BcKernelFunction();
		}
		return function;
	}
	
	/**
	 * @see de.cesr.sonomode.function.KernelFunction#getValue(double, double, double, double)
	 */
	@Override
	public double getValue(double opinionOwn, double opinionOther,
			double uncertaintyOwn, double uncertaintyOther) {
		if (Math.abs(opinionOwn - opinionOther) < uncertaintyOwn) {
			return 1.0;
		} else {
			return 0.0;
		}
	}
}
