/**
 * 
 */
package de.cesr.sonomode.function;

import org.apache.log4j.Logger;

/**
 * @author holzhauer
 *
 */
public class GbcKernelFunction implements KernelFunction {

	/**
	 * Logger
	 */
	static private Logger logger = Logger.getLogger(GbcKernelFunction.class);
	
	private GbcKernelFunction() {};
	
	static KernelFunction function = null;
	
	static public KernelFunction getInstance() {
		if (function == null) {
			function = new GbcKernelFunction();
		}
		return function;
	}
	
	/**
	 * @see de.cesr.sonomode.function.KernelFunction#getValue(double, double, double, double)
	 */
	@Override
	public double getValue(double opinionOwn, double opinionOther,
			double uncertaintyOwn, double uncertaintyOther) {
		
		// <- LOGGING
		if (logger.isDebugEnabled()) {
			logger.debug("Own Opinion: " + opinionOwn + " / Other's opinon: " + opinionOther + " / Own Unvertainty: " + uncertaintyOwn + " / Other's uncertainty: " + uncertaintyOther);
		}
		// LOGGING ->
	
		if (uncertaintyOwn == 0.0) {
			return 0.0;
		} else {
			return Math.exp( - Math.pow((opinionOwn - opinionOther) / uncertaintyOwn, 2.0));
		}
	}

}
