/**
 * 
 */
package de.cesr.sonomode.function;

/**
 * "[...] low uncertainty gives more influence than high uncertainty."
 * 
 * @author holzhauer
 *
 */
public class GbcuKernelFunction implements KernelFunction {

	private GbcuKernelFunction() {};
	
	static KernelFunction function = null;
	
	static public KernelFunction getInstance() {
		if (function == null) {
			function = new GbcuKernelFunction();
		}
		return function;
	}
	
	/**
	 * @see de.cesr.sonomode.function.KernelFunction#getValue(double, double, double, double)
	 */
	@Override
	public double getValue(double opinionOwn, double opinionOther,
			double uncertaintyOwn, double uncertaintyOther) {
		if (uncertaintyOwn == 0.0) {
			return 0.0;
		} else {
			return Math.exp( - Math.pow((opinionOwn - opinionOther) / uncertaintyOwn, 2.0)) * 
					Math.exp( - Math.pow((uncertaintyOther) / uncertaintyOwn, 2.0));
		}
	}
}
