/**
 * 
 */
package de.cesr.sonomode.param;

import de.cesr.parma.core.PmParameterDefinition;
import de.cesr.sonomode.util.MilieuPrefParameterMap;

/**
 * @author holzhauer
 *
 */
public enum MilieuPa implements PmParameterDefinition{
	
	/**
	 * Parameter ID for milieu specific network data
	 */
	MILIEU_PREF_PARAMID(Integer.class, 1),
	
	
	MILIEU_NETPREFS_PARAM(Integer.class, 1),

	/**
	 * The milieu parameter map is usually read by {@link sql.MilieuNetDataReader}
	 */
	MILIEU_PREF_PARAMS(MilieuPrefParameterMap.class, new MilieuPrefParameterMap()),
	
	UNCERTAINTY(Double.class, 0.01),
	
	MUE(Double.class, 0.1);
	

	private Class < ? >	type;
	private Object		defaultValue;

	MilieuPa(Class<?> type) {
		this(type, null);
	}

	MilieuPa(Class<?> type, Object defaultValue) {
		this.type = type;
		this.defaultValue = defaultValue;
	}

	@Override
	public Class < ? > getType() {
		return type;
	}

	@Override
	public Object getDefaultValue() {
		return defaultValue;
	}
}