/**
 * KUBUS_Proto01
 *
 * Center for Environmental Systems Research, Kassel
 * Created by Sascha Holzhauer on 29.06.2010
 */
package de.cesr.sonomode.param;

import de.cesr.parma.core.PmParameterDefinition;



/**
 * KUBUS_Proto01
 * 
 * @author Sascha Holzhauer
 * @date 29.06.2010
 * 
 */
public enum SqlPa implements PmParameterDefinition {
	
	
	DB_SETTINGS_FILE(String.class, "./config/DBSettings.xml"),

	/**
	 * 
	 */
	TBLNAME_MILIEU_GROUPS(String.class, "milieus_milieu_groups"),
	
	
	/**
	 * 
	 */
	TBLNAME_MILIEU_GROUPS_NAMES(String.class,
			"milieu_groups"),

	/**
	 * 
	 */
	TBLNAME_MILIEU_PREFERENCES(String.class, "sonomode_param_milieuprefs"),

	/**
	 * 
	 */
	TBLNAME_HHSTRUCT(String.class, "hhStruktur_abs"),
	
	
	/**
	 * 
	 */
	TBLNAME_MZCOORD(String.class, "mz_koordinaten_mrqr"),
	
	
	/**
	 * 
	 */
	TBLNAME_MZNH(String.class, "mz_nordhessen"),
	
	TBLNAME_RUN_INFO(String.class, "sonomode_runs"),


	
	TBLNAME_NETWORK_MEASURES(String.class, "sonomode_more_net"),
	
	/**
	 * 
	 */
	TBLNAME_NETPREF(String.class, "sonomode_param_net"),
	
	/**
	 * 
	 */
	TBLNAME_NETPREF_LINKS(String.class, "sonomode_param_net_links"),
	
	/**
	 * 
	 */
	TBLNAME_INIT_AGENTS(String.class, "sonomode_param_agents"),;

	private Class < ? >	type;
	private Object		defaultValue;

	SqlPa(Class < ? > type) {
		this(type, null);
	}

	SqlPa(Class < ? > type, Object defaultValue) {
		this.type = type;
		this.defaultValue = defaultValue;
	}

	@Override
	public Class < ? > getType() {
		return type;
	}

	@Override
	public Object getDefaultValue() {
		return defaultValue;
	}
}
