/**
 * 
 */
package de.cesr.sonomode.socnet;

import org.apache.log4j.Logger;

import cern.jet.random.AbstractDistribution;
import cern.jet.random.Uniform;
import de.cesr.more.basic.MManager;
import de.cesr.more.param.MRandomPa;
import de.cesr.more.rs.edge.MRepastEdge;
import de.cesr.parma.core.PmParameterManager;
import de.cesr.sonomode.agent.SonomodeAgent;
import de.cesr.sonomode.param.SocNetPa;

/**
 * @author holzhauer
 *
 */
public class SonomodeEdge extends MRepastEdge<SonomodeAgent> {

	/**
	 * Logger
	 */
	static private Logger logger = Logger.getLogger(SonomodeEdge.class);

	static Uniform rand;

	{
		AbstractDistribution abstractDis = MManager
				.getURandomService()
				.getDistribution(
						(String) PmParameterManager
								.getParameter(MRandomPa.RND_UNIFORM_DIST_NETWORK_BUILDING));

		if (abstractDis instanceof Uniform) {
			rand = (Uniform) abstractDis;
		} else {
			rand = MManager.getURandomService().getUniform();
			logger.warn("Use default uniform distribution");
		}
	}
	
	double change = 0.0;

	public double getChange() {
		return change;
	}

	public void setChange(double change) {
		this.change = change;
	}

	public SonomodeEdge(SonomodeAgent source, SonomodeAgent target,
			boolean directed) {
		super(source, target, directed, 1.0);
		if ((Boolean) PmParameterManager
				.getParameter(SocNetPa.DISTRIBUTE_EDGE_WEIGHTS_UNIFORMLY)) {
			this.setWeight(rand.nextDouble());
		}
	}
}
