package de.cesr.sonomode.socnet.builder;

import de.cesr.more.rs.building.edge.MRsEdgeFactory;
import de.cesr.sonomode.agent.SonomodeAgent;
import de.cesr.sonomode.socnet.SonomodeEdge;

public class SonomodeEdgeFactory extends MRsEdgeFactory<SonomodeAgent, SonomodeEdge> {
	
	private static SonomodeEdgeFactory factory = null;

	private SonomodeEdgeFactory() {
	};

	public static SonomodeEdgeFactory getInstance() {
		if (factory == null) {
			factory = new SonomodeEdgeFactory();
		}
		return factory;
	}

	/**
	 * @see de.cesr.more.building.edge.MoreEdgeFactory#createEdge(java.lang.Object, java.lang.Object, boolean)
	 */
	@Override
	public SonomodeEdge createEdge(SonomodeAgent source, SonomodeAgent target, boolean directed) {
		return new SonomodeEdge(source, target, directed);
	} 
}
