/**
 * 
 */
package de.cesr.sonomode.socnet.manipulate;

import org.apache.log4j.Logger;

import repast.simphony.space.gis.Geography;
import cern.jet.random.AbstractDistribution;
import cern.jet.random.Uniform;
import de.cesr.more.basic.MManager;
import de.cesr.more.manipulate.agent.MBlacklistThresholdLinkProcessor;
import de.cesr.more.manipulate.agent.MoreEgoNetworkProcessor;
import de.cesr.more.manipulate.edge.MoreNetworkEdgeModifier;
import de.cesr.more.param.MRandomPa;
import de.cesr.more.rs.building.MMilieuPartnerFinder;
import de.cesr.more.rs.geo.util.MGeographyWrapper;
import de.cesr.parma.core.PmParameterManager;
import de.cesr.sonomode.agent.SonomodeAgent;
import de.cesr.sonomode.socnet.SonomodeEdge;

/**
 * @author Sascha Holzhauer
 *
 */
public class SonomodeEdgeManager extends MBlacklistThresholdLinkProcessor<SonomodeAgent, SonomodeEdge> implements
		MoreEgoNetworkProcessor<SonomodeAgent, SonomodeEdge> {

	/**
	 * Logger
	 */
	static protected Logger logger = Logger.getLogger(SonomodeEdgeManager.class);


	protected MMilieuPartnerFinder<SonomodeAgent, SonomodeEdge> partnerFinder = new MMilieuPartnerFinder<SonomodeAgent, SonomodeEdge>(
			netParams);

	public SonomodeEdgeManager(
			MoreNetworkEdgeModifier<SonomodeAgent, SonomodeEdge> edgeMan,
			Geography<Object> geography) {
		this(edgeMan);
		this.geoWrapper = new MGeographyWrapper<Object>(geography);
	}
	
	public SonomodeEdgeManager(
			MoreNetworkEdgeModifier<SonomodeAgent, SonomodeEdge> edgeMan) {
		super(edgeMan);
		this.edgeMan = edgeMan;
		AbstractDistribution abstractDis = MManager
				.getURandomService()
				.getDistribution(
						(String) PmParameterManager
								.getParameter(MRandomPa.RND_UNIFORM_DIST_NETWORK_BUILDING));
		
		if (abstractDis instanceof Uniform) {
			this.rand = (Uniform) abstractDis;
		} else {
			this.rand = MManager.getURandomService().getUniform();
			logger.warn("Use default uniform distribution");
		}
	}
}
