/**
 *
 * Center for Environmental Systems Research, Kassel
 * Created by Sascha Holzhauer on 05.01.2011
 */
package de.cesr.sonomode.util;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;

import de.cesr.parma.core.PmParameterDefinition;

/**
 * 
 * @author Sascha Holzhauer
 * @date 05.01.2011
 * 
 */
public class MilieuPrefParameterMap extends
		HashMap<Integer, Map<PmParameterDefinition, Object>> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * Logger
	 */
	static private Logger logger = Logger
			.getLogger(MilieuPrefParameterMap.class);

	/**
	 * @param milieu
	 * @param goal
	 * @return Created by Sascha Holzhauer on 05.01.2011
	 */
	public Object getPref(int milieu, PmParameterDefinition param) {
		if (!this.containsKey(new Integer(milieu))) {
			logger.warn("No values defined for milieu " + milieu);
			return param.getDefaultValue();
		}
		if (!this.get(new Integer(milieu)).containsKey(param)) {
			logger.warn("No values defined for milieu " + milieu + " and goal "
					+ param);
			return param.getDefaultValue();
		}
		return this.get(new Integer(milieu)).get(param);
	}

	/**
	 * @param milieu
	 * @param goal
	 * @param value
	 *            Created by Sascha Holzhauer on 05.01.2011
	 */
	public void setPref(int milieu, PmParameterDefinition param, Object value) {
		if (!this.containsKey(new Integer(milieu))) {
			this.put(new Integer(milieu), new HashMap<PmParameterDefinition, Object>());
		}
		this.get(new Integer(milieu)).put(param, value);
	}
}
